package com.jeeplus.modules.supply.materialLibrary.service;

import com.jeeplus.core.persistence.Page;
import com.jeeplus.core.service.CrudService;
import com.jeeplus.modules.supply.materialLibrary.entity.MaterialLibrary;
import com.jeeplus.modules.supply.materialLibrary.mapper.MaterialLibraryMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

@Service
@Transactional(readOnly = true)
public class MaterialLibraryService extends CrudService<MaterialLibraryMapper, MaterialLibrary> {
    @Autowired
    private MaterialLibraryMapper materialLibraryMapper;

    //页面显示
    public Page<MaterialLibrary> findPage(Page<MaterialLibrary> page,MaterialLibrary materialLibrary){
//        int count = materialLibraryMapper.queryCount(materialLibrary);
//        page.setCount(count);
////        page.setCountFlag(false);
//        materialLibrary.setPage(page);
//        List<MaterialLibrary> materialLibraryList = super.findList(materialLibrary);
//        page.setList(materialLibraryList);
//        return page;
        return super.findPage(page,materialLibrary);
    }

    //物流库信息导入处理
    @Transactional(readOnly = false)
    public String disposeImportMaterialLibrary(List<MaterialLibrary> list){
        Set<String> materialCodeSet = new HashSet<>();
        for (MaterialLibrary importInfo : list){
            //将物料编码放入set中
            materialCodeSet.add(importInfo.getMaterialCode());
        }
        //将set转换为list
        List<String> materialCodeList = new ArrayList<>(materialCodeSet);

        //判断物流编码list长度和导入数据的list长度是否一样，不一样则说明导入数据中项目名存在重复数据
        if(materialCodeList.size() != list.size()){
            return "数据中存在重复物流编码";
        }

        //批量按物流编码查询，如果不为null则返回提醒字符串   //已存在物料数据，是否覆盖？   覆盖：物理删除旧数据，保存新数据   +++判断传参是否不为yes
        if(!materialLibraryMapper.getCountByMaterialCodeList(materialCodeList).equals("0")){
            return "已存在物料数据，是否覆盖？";
        }

        //找到对应重复数据，以便最后批量擦做使用





        //是否覆盖  前端传个参数   是覆盖
        //if(传参为空||yes)则覆盖 else 不覆盖
        //if
        materialLibraryMapper.deleteMaterialLibraryByMaterialCodeList(materialCodeList);
        //批量新增  分批次新增


        return "";
    }
}
