package com.jeeplus.modules.supply.materialLibrary.web;

import com.jeeplus.common.utils.StringUtils;
import com.jeeplus.core.persistence.Page;
import com.jeeplus.core.web.BaseController;
import com.jeeplus.modules.supply.materialLibrary.entity.MaterialLibrary;
import com.jeeplus.modules.supply.materialLibrary.service.MaterialLibraryService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.List;

@Controller
@RequestMapping(value = "${adminPath}/supply/materialLibrary")
public class MaterialLibraryController extends BaseController {

    @Autowired
    private MaterialLibraryService materialLibraryService;

    @ModelAttribute
    public MaterialLibrary get(@RequestParam(required = false) String id) {
        MaterialLibrary entity = null;
        if (StringUtils.isNotBlank(id)) {
            entity = materialLibraryService.get(id);
        }
        if (entity == null) {
            entity = new MaterialLibrary();
        }
        return entity;
    }

    /**
     * 项目列表页面
     */
//    @RequiresPermissions("superOwed:materialLibrary:list")
    @RequestMapping(value = {"list", ""})
    public String list(MaterialLibrary materialLibrary, HttpServletRequest request, HttpServletResponse response, Model model) {


        //获取项目信息
        Page<MaterialLibrary> page = materialLibraryService.findPage(new Page<MaterialLibrary>(request, response), materialLibrary);


        model.addAttribute("page", page);
        return "modules/ruralprojectrecords/ruralProjectRecordsList";
    }

}
